Summary: Determines which system packages need to be updated
License: GPL
Group: System Environment/Base
Source0: %{name}-%{version}-xos.tar.gz
Patch0: up2date-4.4.50-yum-obsoletes.patch
Patch1: up2date-4.4.50-apt-mirror.patch
Patch2: up2date-4.4.50-userpassword.patch
Patch3: up2date-4.4.50-yumx.patch
Url: http://rhn.redhat.com
Name: up2date
Version: 4.4.67
Release: 4.XOS.1
BuildRoot: %{_tmppath}/%{name}-root
Requires: python >= 2.2.2
#Requires: rpm >= 4.1-1.05
Requires: rpm >= 4.2.3-24_nonptl
Requires: libxml2-python
Requires: rpm-python 
Requires: gnupg
Requires: sh-utils
Obsoletes: rhn_register

%define is_RHEL_3 0

%if %{is_RHEL_3} 
Requires: rhnlib >= 1.3-12
%else
Requires: rhnlib >= 1.8.1
%endif 
Prereq: /sbin/chkconfig
Requires: mkinitrd >= 3.2.2
Requires: python-optik
Requires: rhpl >= 0.81-2
Requires: perl
Requires: newt
Obsoletes: up2date-update

# for uuidgen, we need:
Requires: e2fsprogs

BuildRequires: desktop-file-utils
BuildRequires: python >= 2.2.2-7
BuildRequires: python-devel
BuildRequires: gettext
BuildRequires: intltool


%define pythonver python%(%{__python} -c "import sys; print sys.version[:3]")

# only need mkinitrd on x86 and only grubby on 7.2 or higher
%ifnarch i386 ia64 
%define needsmkinitrd  0
%else
%define needsmkinitrd 1
%endif

# test if we build this on X/OS Linux
%define xoslinux %(test -f /etc/xos-release && echo 1 || echo 0)

%description
The X/OS Linux Update Agent that automatically queries the X/OS Linux
repository servers and determines which packages need to be updated on
your machine.

%package gnome
Summary: A GUI interface for Update Agent.
Group: System Environment/Base
Url: http://rhn.redhat.com
Requires: %{name} = %{version}
Requires: usermode >= 1.36
Requires: pam >= 0.72
Requires: pygtk2 pygtk2-libglade gnome-python2 gnome-python2-canvas 
Requires: usermode-gtk
Obsoletes: rhn_register-gnome



%description gnome
The up2date-gnome package contains a GNOME interface for the X/OS Linux
Update Agent.

%prep
%setup -q 
%patch0 -p1
%patch1 -p1
%patch2 -p1
%patch3 -p1

%build
# put the packages in the right lib for lib64
make LIBDIR=%{_libdir} PYTHON_VER=%{pythonver}

%install
# only needed for 6.x
rm -fr $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT

# we need to install the sources file for RHEL3, see bz #162071 
%if %{is_RHEL_3}
make install VERSION=%{version}-%{release} PREFIX=$RPM_BUILD_ROOT MANPATH=%{_mandir} LIBDIR=%{_libdir} PYTHON_VER=%{pythonver} RHEL3=1
%else
%if %{xoslinux}
make install VERSION=%{version}-%{release} PREFIX=$RPM_BUILD_ROOT MANPATH=%{_mandir} LIBDIR=%{_libdir} PYTHON_VER=%{pythonver} XOSLINUX=1
%else
make install VERSION=%{version}-%{release} PREFIX=$RPM_BUILD_ROOT MANPATH=%{_mandir} LIBDIR=%{_libdir} PYTHON_VER=%{pythonver}
%endif
%endif

mkdir -p $RPM_BUILD_ROOT/etc/sysconfig/rhn
mkdir -p $RPM_BUILD_ROOT/var/spool/up2date
mkdir -p $RPM_BUILD_ROOT/var/lib/up2date

# install the rhnsd init script
mkdir -p $RPM_BUILD_ROOT/etc/rc.d/init.d/
install -m 755 rhnsd.init $RPM_BUILD_ROOT/etc/rc.d/init.d/rhnsd

# install config file
install -m 644 rhnsd.sysconfig $RPM_BUILD_ROOT/etc/sysconfig/rhn/rhnsd

# these are the same man page...
ln -s %{_mandir}/man8/up2date.8 $RPM_BUILD_ROOT/%{_mandir}/man8/up2date-nox.8

%find_lang %{name}

desktop-file-install --vendor redhat --delete-original       \
  --dir $RPM_BUILD_ROOT%{_datadir}/applications             \
  --add-category X-Red-Hat-Base                             \
  $RPM_BUILD_ROOT%{_datadir}/applications/redhat-rhn-up2date.desktop

# Compile .pyc again #69205
set -x
find $RPM_BUILD_ROOT%{_datadir}/rhn -name '*.pyc' |xargs rm
%{__python} -c "import compileall; compileall.compile_dir('$RPM_BUILD_ROOT%{_datadir}/rhn', ddir='%{_datadir}/rhn')"

%post
# if old configuration exists, copy it into place
if [ -f /etc/up2date.conf ]; then
    cp /etc/up2date.conf /etc/sysconfig/rhn/up2date
fi

/sbin/chkconfig --add rhnsd

UUID=$(/usr/bin/uuidgen -t)
perl -p -i -e "s/UNSPECIFIED/$UUID/g" /etc/sysconfig/rhn/up2date-uuid


%preun
if [ $1 = 0 ] ; then
    /etc/rc.d/init.d/rhnsd stop >/dev/null 2>&1
    /sbin/chkconfig --del rhnsd
fi


%postun
if [ "$1" -ge "1" ]; then
    /etc/rc.d/init.d/rhnsd condrestart >/dev/null 2>&1
fi

%triggerpostun -- up2date <= 2.0.4
if [ "$1" -ge "1" ]; then
    /etc/rc.d/init.d/rhnsd condrestart >/dev/null 2>&1
fi

%clean
rm -fr $RPM_BUILD_ROOT


%files -f %{name}.lang
%defattr(-,root,root)
# some info about mirrors
%doc ChangeLog mirrors.txt fedora-core-1 updates-released
%dir /etc/sysconfig/rhn
%dir /etc/sysconfig/rhn/clientCaps.d
%dir /etc/rpm/
%config(noreplace) /etc/sysconfig/rhn/up2date
%config(noreplace) /etc/logrotate.d/up2date

# in rhel4/fc this file moved to redhat-releases
%if %{is_RHEL_3}
%config(noreplace) /etc/sysconfig/rhn/sources
%endif

%config /etc/security/console.apps/up2date
%config /etc/security/console.apps/up2date-nox
%config /etc/security/console.apps/up2date-config
%config /etc/security/console.apps/rhn_register
%config /etc/pam.d/up2date
%config /etc/pam.d/up2date-config
%config /etc/pam.d/up2date-nox
%config /etc/pam.d/rhn_register

#modules
%{_libdir}/%{pythonver}/site-packages/dmimodule.so


# dirs
%dir /usr/share/rhn
%dir /usr/share/rhn/up2date_client
%dir /usr/share/rhn/up2date_client/repoBackends

#files
/usr/bin/up2date
/usr/bin/rhn_register
/usr/sbin/up2date
/usr/sbin/rhn_register
/usr/sbin/rhnreg_ks
/usr/bin/up2date-config
/usr/sbin/up2date-config
/usr/bin/up2date-nox
/usr/sbin/up2date-nox
/usr/bin/go-rhn.sh
/usr/share/rhn/up2date_client/__init__.*
/usr/share/rhn/up2date_client/configUtils.*
/usr/share/rhn/up2date_client/config.*
/usr/share/rhn/up2date_client/hardware.*
/usr/share/rhn/up2date_client/up2date.*
/usr/share/rhn/up2date_client/wrapper.*
/usr/share/rhn/up2date_client/iutil.*
/usr/share/rhn/up2date_client/lilo.*
/usr/share/rhn/up2date_client/grubcfg.*
/usr/share/rhn/up2date_client/lilocfg.*
/usr/share/rhn/up2date_client/elilocfg.*
/usr/share/rhn/up2date_client/checkbootloader.*
/usr/share/rhn/up2date_client/bootloadercfg.*
/usr/share/rhn/up2date_client/text_config.*
/usr/share/rhn/up2date_client/rhnreg.*
/usr/share/rhn/up2date_client/rpmSource.*
/usr/share/rhn/up2date_client/getMethod.*
/usr/share/rhn/up2date_client/rhnDefines.*
/usr/share/rhn/up2date_client/up2dateUtils.*
/usr/share/rhn/up2date_client/wrapperUtils.*
/usr/share/rhn/up2date_client/up2dateLog.*
/usr/share/rhn/up2date_client/up2dateMessages.*
/usr/share/rhn/up2date_client/up2dateErrors.*
/usr/share/rhn/up2date_client/up2dateAuth.*
/usr/share/rhn/up2date_client/up2dateComps.*
/usr/share/rhn/up2date_client/rpcServer.*
/usr/share/rhn/up2date_client/rpmUtils.*
/usr/share/rhn/up2date_client/rhnPackageInfo.*
/usr/share/rhn/up2date_client/packageList.*
/usr/share/rhn/up2date_client/headers.*
/usr/share/rhn/up2date_client/depSolver.*
/usr/share/rhn/up2date_client/up2dateBatch.*
/usr/share/rhn/up2date_client/gpgUtils.*
/usr/share/rhn/up2date_client/rhnChannel.*
/usr/share/rhn/up2date_client/rhnErrata.*
/usr/share/rhn/up2date_client/rollbacks.*
/usr/share/rhn/up2date_client/rhnHardware.*
/usr/share/rhn/up2date_client/transaction.*
/usr/share/rhn/up2date_client/tui.*
/usr/share/rhn/up2date_client/distrotype.*
/usr/share/rhn/up2date_client/clientCaps.*
/usr/share/rhn/up2date_client/capabilities.*
/usr/share/rhn/up2date_client/sourcesConfig.*
/usr/share/rhn/up2date_client/rpmSourceUtils.*
/usr/share/rhn/up2date_client/urlMirrors.*
/usr/share/rhn/up2date_client/rhnregGui.*
/usr/share/rhn/up2date_client/messageWindow.*
/usr/share/rhn/up2date_client/repoDirector.*
/usr/share/rhn/up2date_client/timeoutsocket.*
/usr/share/rhn/up2date_client/rh_register.glade
/usr/share/rhn/up2date_client/repoBackends/__init__*
/usr/share/rhn/up2date_client/repoBackends/aptRepo.*
/usr/share/rhn/up2date_client/repoBackends/dirRepo.*
/usr/share/rhn/up2date_client/repoBackends/genericRepo.*
/usr/share/rhn/up2date_client/repoBackends/up2dateRepo.*
/usr/share/rhn/up2date_client/repoBackends/genericSolveDep.*
/usr/share/rhn/up2date_client/repoBackends/urlUtils.*
/usr/share/rhn/up2date_client/repoBackends/yumRepo.*
/usr/share/rhn/up2date_client/repoBackends/cmdlineRepo.*
/usr/share/rhn/up2date_client/repoBackends/importmetadata.*
/usr/share/rhn/up2date_client/repoBackends/mdErrors.*
/usr/share/rhn/up2date_client/repoBackends/mdUtils.*
/usr/share/rhn/up2date_client/repoBackends/packageObject.*
/usr/share/rhn/up2date_client/repoBackends/packageSack.*
/usr/share/rhn/up2date_client/repoBackends/repoMDObject.*
/usr/share/rhn/up2date_client/repoBackends/rpmmdRepo.*
/usr/share/rhn/up2date_client/repoBackends/repomdRepo.*
/usr/share/rhn/up2date_client/repoBackends/yumBaseRepo.*
/usr/share/rhn/__init__.*

# actions for rhn_check to run
/usr/share/rhn/actions/__init__.*
/usr/share/rhn/actions/hardware.*
/usr/share/rhn/actions/errata.*
/usr/share/rhn/actions/packages.*
/usr/share/rhn/actions/systemid.*
/usr/share/rhn/actions/rollback.*
/usr/share/rhn/actions/reboot.*
/usr/share/rhn/actions/rhnsd.*
/usr/share/rhn/actions/up2date_config.*


# firstboot is smart enough now to skip these modules
# if the modules say to
/usr/share/firstboot/modules/rhn_activate_gui.*
/usr/share/firstboot/modules/rhn_newaccount_gui.*
/usr/share/firstboot/modules/rhn_shared.*
/usr/share/firstboot/modules/rhn_login_gui.*
/usr/share/firstboot/modules/rhn_optout_gui.*

%{_mandir}/man8/*


#public keys and certificates
/usr/share/rhn/RHNS-CA-CERT
/usr/share/rhn/*RPM-GPG-KEY*

%config(noreplace) /etc/sysconfig/rhn/up2date-keyring.gpg
%config(noreplace) /etc/sysconfig/rhn/up2date-uuid
%config /etc/sysconfig/rhn/rhnsd
%config /etc/rpm/macros.up2date
/usr/sbin/rhnsd
/usr/sbin/rhn_check
/etc/rc.d/init.d/rhnsd
%dir /var/spool/up2date
%dir /var/lib/up2date

%files gnome
%defattr(-,root,root)
#desktop files
%{_datadir}/applications/* 

/usr/share/rhn/up2date_client/gui.*
/usr/share/rhn/up2date_client/configdlg.*
/usr/share/rhn/up2date_client/progress.*
/usr/share/rhn/up2date_client/checklist.*
/usr/share/rhn/up2date_client/*png
/usr/share/pixmaps/*png


%changelog
* Sat Mar 11 2006 X/OS Linux Team <xoslinux@xos.nl> 4.4.67-4.XOS.1
- Fix bug with processing package lists in yumRepo's getObsoletes().
- Fix bug with handling apt mirror source lines.
- Add "user:password@host" syntax support in URL's.
- Add support for extended yum repositories with package sizes.
- Replace RHEL tarball by a X/OS Linux-specific tarball.

* Tue Jan 31 2006 Bret McMillan <bretm@redhat.com> 4.4.67-4
- fix release tag

* Fri Jan 27 2006 Adrian Likins <alikins@redhat.com> 4.4.67-3
- fix for #179110 - up2date fails to update xerces-j
- more fixed for #176195 "up2date-nox --configure changes current value of numeric attribute to Yes/No if 1/0 is selected"

* Fri Jan 27 2006 Bret McMillan <bretm@redhat.com> 4.4.65-3
- fix for #176195 "up2date-nox --configure changes current value of numeric attribute to Yes/No if 1/0 is selected"

* Thu Jan 19 2006 Adrian Likins <alikins@redhat.com> 4.4.63-4
- rest of fix for #169880 up2date --arch updates primary arch if package is out of date instead of arch specified.
- even better fix for #178261 "Invalid function call attempted" when installing a RHN proxy

* Thu Jan 19 2006 Bret McMillan <bretm@redhat.com> 4.4.60-4
- rebuild with fixes for:
- fix #169293 -- up2date unable to download very large rpms
- fix #177784 -- up2date gives error if select-all is checked
- fix #177786 -- up2date unselects all pakcages if select-all is checked and user selects 'back'

* Thu Jan 12 2006 Adrian Likins <alikins@redhat.com> 4.4.58
- fix for #165157 - firstboot 'Read our Privacy Statement' shows a blank text box

* Fri Jan 6 2006 Adrian Likins <alikins@redhat.com> 4.4.56-4.1
- rebuild for #176182 (new gcc)

* Thu Dec 8 2005 Adrian Likins <alikins@redhat.com> 4.4.55
- add bug fix for  #175321  rhnreg_ks cannot import name capabilities -- circular import

* Wed Nov 15 2005 Adrian Likins <alikins@redhat.com> 4.4.54
- revert orig fix for #165024 - "invalid function call" error on proxy installs
- add new bug fix for #165204
- revert "fix" for #169882, #159955 - up2date man page does not describe --undo option.
- add --unfo to man page fixing #169882, #159955


* Wed Nov 09 2005 Adrian Likins <alikins@redhat.com> 4.4.52
- fix #165024 - "invalid function call" error on proxy installs
- fix #169881, #167732 -  'up2date --configure' always saves changes if useNetwork is false on startup
 

* Mon Oct 10 2005 Adrian Likins <alikins@redhat.com> 4.4.51
- fix #169882, #159955 - up2date man page does not describe --undo option.
  (remove deprecated undo option)
- fix #170065, #166034 - up2date "forward" button disabled if packages selected via spacebar.
- fix #157087, #170055 - up2date --configure fails when failover serverURL is configured.

* Thu Sep 15 2005 Adrian Likins <alikins@redhat.com> 4.4.50-4
- new up2date.pot, synced up
- fix uncommitted changes that were causing string 
  translations not to show up
- more translations updates for #160608

* Mon Sep 12 2005 Adrian Likins <alikins@redhat.com> 4.4.45
- fix for #160602 (updated russian translations)


* Fri Aug 26 2005 Adrian Likins <alikins@redhat.com> 4.4.44
- fix for #166868 - fatal python error when  installing package

* Tue Aug 23 2005 Adrian Likins <alikins@redhat.com> 4.4.43
- more fixes for #144800

* Tue Aug 23 2005 Adrian Likins <alikins@redhat.com> 4.4.42
- more fixes for #159858/#157070

* Mon Aug 15 2005 Adrian Likins <alikins@redhat.com> 4.4.41
- fix #164660

* Thu Aug 11 2005 Adrian Likins <alikins@redhat.com> 4.4.40
- attempt "fix" for #165636 (require new rpm versions)

* Wed Aug 10 2005 Adrian Likins <alikins@redhat.com> 4.4.39
- more fix for #157070
- require newer rhnlib for #165360

* Thu Aug 4 2005 Adrian Likins <alikins@redhat.com> 4.4.38
- fix desktop files rpmdiff complained about

* Thu Aug 4 2005 Adrian Likins <alikins@redhat.com> 4.4.37
- fix specfile to work on ppc

* Wed Aug 3 2005 Adrian Likins <alikins@redhat.com> 4.4.36
- fix for #162701

* Wed Aug 3 2005 Adrian Likins <alikins@redhat.com> 4.4.35
- fix for #160602 (updated ru.po)

* Tue Aug 2 2005 Adrian Likins <alikins@redhat.com> 4.4.34
- fix for #144800

* Thu Jul 28 2005 Adrian Likins <alikins@redhat.com> 4.4.33
- fix for #149472

* Wed Jul 27 2005 Adrian Likins <alikins@redhat.com> 4.4.32
- fix for #144800
- fix for #137942

* Tue Jul 26 2005 Adrian Likins <alikins@redhat.com> 4.4.31
- fix for #155583

* Tue Jul 12 2005 Adrian Likins <alikins@redhat.com> 4.4.30
- more fixes for sources on RHEL-3
- have to include "3" as a release as well

* Mon Jul 11 2005 Adrian Likins <alikins@redhat.com> 4.4.28
- fix for issues with updating the package list after
  actions correctly #125790

* Thu Jul 7 2005 Jason Connor <jconnor@redhat.com> 4.4.27.2
- hotfix for bug 148952

* Tue Jun 7 2005 Adrian Likins <alikins@redhat.com> 4.4.25
- delay/avoid doing repomd if it's not in use

* Mon Jun 6 2005 Adrian Likins <alikins@redhat.com> 4.4.24
- dont require the old extended_packages cap

* Thu May 19 2005 Adrian Likins <alikins@redhat.com> 4.4.23
- change the way the version substitution works to pass pkg checker

* Thu May 19 2005 Adrian Likins <alikins@redhat.com> 4.4.22
- fix #158256 - up2date errors if yum isnt installed, but doesn't need to

* Thu May 19 2005 Adrian Likins <alikins@redhat.com> 4.4.20
- fix #154814 -  Selecting all packages in the GUI only selects first package

* Tue May 17 2005 Adrian Likins <alikins@redhat.com> 4.4.19
- fix #155583 - don't allow kernel-smp.x86_64 to be installed on ia32e
- fix #157070 - make yum/apt repos support proxies
- fix #148952 - patch from Jack Neely <jjneely@pams.ncsu.edu)

* Mon May 16 2005 Adrian Likins <alikins@redhat.com> 4.4.19
- fix #150418 – rhel-4 client machine capabilities not recognized sometimes
- fix #145554 – rhn_register fails if proxy username begins at '0'
- fix #154137 up2date does not always send the arch

* Mon May 9 2005 Adrian Likins <alikins@redhat.com> 4.4.18
- fix problem with missing import

* Wed Apr 27 2005 Adrian Likins <alikins@redhat.com> 4.4.17
- fix some bugs in the way repomdRepo creates the package lists

* Tue Apr 26 2005 Adrian Likins <alikins@redhat.com> 4.4.16
- support repomd repos (and use the yum config if it exists)
  bugzilla #135121

* Tue Apr 19 2005 Adrian Likins <alikins@redhat.com> 4.4.15
- fix #149444 up2date --dry-run --upgrade-to-release changes registered base channel
- fix #151328 (tracback when registering with *'s in password)
- added some general uncaught exception catching
- truncate rpm changelog (see up2date.spec.changelog)
- update translations

* Thu Apr 14 2005 Jason Connor <jconnor@redhat.com> 4.4.14
- fix #135121 - uncommented rpmmd registration, fixed api
- fix #149281 - added check for failed read

* Fri Apr 8 2005 Adrian Likins <alikins@redhat.com> 4.4.13
- update translations

* Thu Apr 7 2005 Adrian Likins <alikins@redhat.com> 4.4.12
- update translations

* Thu Mar 3 2005 Adrian Likins <alikins@redhat.com> 4.4.10
- fix #150210
- revert change for package list refresh for this
  release

* Tue Mar 1 2005 Adrian Likins <alikins@redhat.com> 4.4.9
- fix #149947

* Tue Feb 15 2005 Adrian Likins <alikins@redhat.com> 4.4.8
- fix #139537

* Fri Jan 14 2005 Adrian Likins <alikins@redhat.com> 4.4.7
- fix #136497
- fix #142750, #142589 (less deprecation warnings) 

* Mon Jan 10 2005 Adrian Likins <alikins@redhat.com> 4.4.6
- fix #144704

* Wed Dec 15 2004 Adrian Likins <alikins@redhat.com> 4.4.5
- fix #142406 (again)

* Wed Dec 15 2004 Adrian Likins <alikins@redhat.com> 4.4.4
- fix #142332
- fix #129909

* Tue Dec 14 2004 Adrian Likins <alikins@redhat.com> 4.4.3
- fix #142406

* Mon Dec 6 2004 Adrian Likins <alikins@redhat.com> 4.4.2
- fix #139495 (updated translations)

* Fri Dec 3 2004 Adrian Likins <alikins@redhat.com> 4.4.1
- fix #141820 (add kernel-devel to list of packages to
  intall not update)

* Fri Dec 3 2004 Adrian Likins <alikins@redhat.com> 4.4.0
- rev to 4.4.0
